﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace AutolaskuriControl
{
    /// <summary>
    /// Interaction logic for UserControl1.xaml
    /// </summary>
    public partial class Autolaskuri : UserControl
    {
//        private int laskuri = 0;
        public Autolaskuri()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Laskuri++;
            // ei tarvita enää, kun on määritelty LaskuriProperty
            //            label1.Content = laskuri.ToString();
        }

        // nimeäminen tehtävä juuri seuraavalla tavalla
        public static readonly DependencyProperty LaskuriProperty =
         DependencyProperty.Register(
           "Laskuri",
           typeof(int), // propertyn tietotyyppi
           typeof(Autolaskuri), // luokka jossa property sijaitsee
           new FrameworkPropertyMetadata(0,  // propertyn oletusarvo
              FrameworkPropertyMetadataOptions.AffectsRender, // vaikuttaa luokan ulkoasuun (textbox päivittyy)
              new PropertyChangedCallback(OnValueChanged),  // kutsutaan propertyn arvon muuttumisen jälkeen
              new CoerceValueCallback(MuutaLaskuria))); // kutsutaan ennen propertyn arvon muutosta

        // seuraavat tehtävä juuri näin. Ei mitään tarkistuksien lisäämistä
        public int Laskuri
        {
           get { return (int)GetValue(LaskuriProperty); }
           set { SetValue(LaskuriProperty, value); }
        }

        // tätä kutsutaan ennen laskurin muuttamista ja voidaan tässä vaiheessa
        // tehdä tarkistuksia ja muuttaa laskuriin asetettavaa arvoa
        private static object MuutaLaskuria(DependencyObject element, object value)
        {
           int luku = (int)value;
           if (luku < 0) value = 0;

           return luku;
        }

        // Laskuria on muutettu. Päivitetään tieto myös labeliin
        private static void OnValueChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
           Autolaskuri o = (Autolaskuri)obj;
           o.label1.Content = args.NewValue;
        }

    }
}
